
#include <cstdlib>
#include <cstring>

#include "lg/interface.h"
#include "lg/scrservices.h"
#include "lg/scrmanagers.h"
#include "lg/scrmsgs.h"
#include "ScriptLib.h"
#include "Interaction.h"


/*****************
 * KnockOnDoor
 */
long __stdcall cScr_KnockOnDoor::OnFrob(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<ILockSrv> pLockSrv(g_pScriptManager);
	SService<IDoorSrv> pDoorSrv(g_pScriptManager);
	if (pLockSrv->IsLocked(m_iObjId) && pDoorSrv->GetDoorState(m_iObjId) == kDoorStateClosed)
	{
		SService<IAIScrSrv> pAISrv(g_pScriptManager);
#if (_DARKGAME == 3)
		IterateLinksByData("ScriptParams", 0, m_iObjId, "Owns", -1, LinkIterFunc, this, reinterpret_cast<void*>(pAISrv.get()));
#else
		IterateLinks("Owns", 0, m_iObjId, LinkIterFunc, this, reinterpret_cast<void*>(pAISrv.get()));
#endif
	}
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

int cScr_KnockOnDoor::LinkIterFunc(ILinkSrv* pLS, ILinkQuery* pLQ, IScript* pScript, void* pData)
{
	IAIScrSrv* pAISrv = reinterpret_cast<IAIScrSrv*>(pData);
	sLink sl;
	pLQ->Link(&sl);
	pAISrv->Signal(sl.source, "knock_knock");
	SimplePost(static_cast<cScr_KnockOnDoor*>(pScript)->m_iObjId, sl.source, "Interact", "knock_knock");
	return 1;
}


#if (_DARKGAME != 3)
/********************
 * OnScreenText
 */
int cScr_OnScreenText::DisplayPage(int page)
{
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (!pPS->Possessed(m_iObjId, "Book"))
	{
		DebugString("Object has no book!");
		return 1;
	}
	cMultiParm mpBook;
	pPS->Get(mpBook, m_iObjId, "Book", NULL);
	if (!*mpBook.psz)
	{
		DebugString("Object has no book!");
		mpBook.Free();
		return 1;
	}
	SService<IDarkUISrv> pUI(g_pScriptManager);
	SService<IDataSrv> pDS(g_pScriptManager);
	char* pszBookFile = new char[strlen(mpBook.psz) + 10];
	strcpy(pszBookFile, "..\\books\\");
	strcat(pszBookFile, mpBook);
	char szPage[16], szPageExtra[24];
	sprintf(szPage, "page_%d", page);
	cScrStr strPage, strColor, strTime, strNext, strAuto;
	pDS->GetString(strPage, pszBookFile, szPage, "", "strings");
	if (!strPage.IsEmpty())
	{
		int iColor = RGB(255,255,255);
		int iTime = 0;
		sprintf(szPageExtra, "%s_color", szPage);
		pDS->GetString(strColor, pszBookFile, szPageExtra, "", "strings");
		if (!strColor.IsEmpty())
		{
			iColor = strtocolor(strColor);
		}
		strColor.Free();
		sprintf(szPageExtra, "%s_time", szPage);
		pDS->GetString(strTime, pszBookFile, szPageExtra, "", "strings");
		if (!strTime.IsEmpty())
		{
			int wait = strtotime(strTime);
			if (wait > 0)
				iTime = wait;
		}
		strTime.Free();
		if (iTime == 0)
		{
			iTime = CalcTextTime(strPage);
		}
		pUI->TextMessage(strPage, iColor, iTime);
		strPage.Free();

		sprintf(szPageExtra, "%s_auto", szPage);
		pDS->GetString(strAuto, pszBookFile, szPageExtra, "", "strings");
		if (!strAuto.IsEmpty())
		{
			int wait = strtotime(strAuto);
			if (wait == 0 && strAuto[0] == '0')
				wait = iTime;
			if (wait > 0)
			{
				if (m_hAutoScroll != NULL)
					g_pScriptManager->KillTimedMessage(m_hAutoScroll);
				m_hAutoScroll = g_pScriptManager->SetTimedMessage2(m_iObjId, "AutoScroll", 
						(wait < iTime) ? iTime : wait, kSTM_OneShot, g_mpUndef);
			}
		}
		strAuto.Free();
		++page;
		sprintf(szPageExtra, "%s_next", szPage);
		pDS->GetString(strNext, pszBookFile, szPageExtra, "", "strings");
		if (!strNext.IsEmpty())
		{
			int next = strtoul(strNext, NULL, 10);
			page = next;
		}
		strNext.Free();
		sprintf(szPage, "page_%d", page);
		pDS->GetString(strPage, pszBookFile, szPage, "", "strings");
		if (strPage.IsEmpty())
			page = 0;
		strPage.Free();
		ChangePage(page);
	}
	else
	{
		strPage.Free();
	}
	delete[] pszBookFile;
	mpBook.Free();

	return 0;
}

int cScr_OnScreenText::ChangePage(int page)
{
	return SetObjectParamInt(m_iObjId, "page", page);
}

long cScr_OnScreenText::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (m_hAutoScroll != NULL)
	{
		g_pScriptManager->KillTimedMessage(m_hAutoScroll);
		m_hAutoScroll = NULL;
	}
	int page = GetObjectParamInt(m_iObjId, "page");
	if (page < 0)
		page = 0;
	DisplayPage(page);
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

long cScr_OnScreenText::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

enum eOSTOps
{
	kOSTSet = '@',
	kOSTDisplay = '#',
	kOSTNext = '+',
	kOSTPrev = '-',
	kOSTFile = '$' // unimplemented
};

long cScr_OnScreenText::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	char op = kOSTSet;
	int iArg = -1;
	switch (pMsg->data.type)
	{
	case kMT_Int:
		iArg = pMsg->data.i;
		break;
	case kMT_Float:
		iArg = static_cast<int>(pMsg->data.f);
		break;
	case kMT_String:
		if (pMsg->data.psz)
		{
			char* pszEnd;
			int iNum = strtoul(pMsg->data.psz, &pszEnd, 10);
			if (pszEnd && *pszEnd == '\0')
				iArg = iNum;
			else
			{
				const char* pszArg = pMsg->data.psz + 1;
				op = pMsg->data.psz[0];
				if (pszArg[0] == '.')
					iArg = INT_MAX;
				else
					iArg = strtoul(pszArg, &pszEnd, 10);
			}
		}
		break;
	default:
		if (pReply)
			MultiParmAssignInt(pReply, 0);
		return 0;
	}
	if (iArg > 0)
	{
		int iPage = GetObjectParamInt(m_iObjId, "page");
		if (iArg == INT_MAX)
			iArg = iPage;
		switch (op)
		{
		case kOSTSet:
			if (iPage != iArg)
				ChangePage(iArg);
			break;
		case kOSTDisplay:
			DisplayPage(iArg);
			break;
		case kOSTNext:
		{
			int iNewPage = iPage + iArg;
			if (iPage != iNewPage)
				ChangePage(iNewPage);
			break;
		}
		case kOSTPrev:
		{
			int iNewPage = iPage - iArg;
			if (iNewPage < 0)
				iNewPage = 0;
			if (iPage != iNewPage)
				ChangePage(iNewPage);
			break;
		}
		default:
			if (pReply)
				MultiParmAssignInt(pReply, 0);
			return 0;
		}
	}
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

long __stdcall cScr_OnScreenText::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sScrTimerMsg* pTimerMsg = static_cast<sScrTimerMsg*>(pMsg);
	if (stricmp(static_cast<const char*>(pTimerMsg->name),"AutoScroll"))
		return 1;

	m_hAutoScroll = NULL;
	DisplayPage(GetObjectParamInt(m_iObjId, "page"));
	return 0;
}
#endif


#if (_DARKGAME != 3)
/*****************
 * InteractFrobHack
 */
long __stdcall cScr_InteractFrobHack::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	bool bIsDead = true;
	SService<IPropertySrv> pPS(g_pScriptManager);
	cMultiParm mpAIProp;
	if (pPS->Possessed(m_iObjId, "AI"))
	{
		pPS->Get(mpAIProp, m_iObjId, "AI", "Behavior set");
		if (stricmp(static_cast<const char*>(mpAIProp),"null") != 0)
		{
			cMultiParm mpMode;
			if (pPS->Possessed(m_iObjId, "AI_Mode"))
			{
				pPS->Get(mpMode, m_iObjId, "AI_Mode", NULL);
				bIsDead = static_cast<int>(mpMode) == kAIM_Dead;
			}
			else
				bIsDead = false;
		}
		mpAIProp.Free();
	}

	if (bIsDead)
		RemoveSingleMetaProperty("FrobInteract", m_iObjId);
	else
		AddSingleMetaProperty("FrobInteract", m_iObjId);

	return 0;
}

long __stdcall cScr_InteractFrobHack::OnAIModeChange(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sAIModeChangeMsg*>(pMsg)->mode == kAIM_Dead)
	{
		RemoveSingleMetaProperty("FrobInteract", m_iObjId);
	}
	else if (static_cast<sAIModeChangeMsg*>(pMsg)->previous_mode == kAIM_Dead)
	{
		AddSingleMetaProperty("FrobInteract", m_iObjId);
	}
	return 0;
}

long __stdcall cScr_InteractFrobHack::OnSlain(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	RemoveSingleMetaProperty("M-KnockedOut", m_iObjId);

	SService<IPropertySrv> pPS(g_pScriptManager);
	if (pPS->Possessed(m_iObjId, "PhysType"))
	{
		cMultiParm mpProp(true);
		pPS->Set(m_iObjId, "PhysType", "Remove on Sleep", mpProp);
	}

	return 0;
}

long __stdcall cScr_InteractFrobHack::OnFrobWorldEnd(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
#if (_DARKGAME == 2)
	// Unlike CorpseFrobInert, we may get a frob while the AI
	// is still alive.
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (!pPS->Possessed(m_iObjId, "AI_Mode"))
	{
		return 0;
	}
	cMultiParm mpMode;
	pPS->Get(mpMode, m_iObjId, "AI_Mode", NULL);
	if (static_cast<int>(mpMode) == kAIM_Dead)
	{
		SService<IDarkGameSrv> pGS(g_pScriptManager);
		if (pGS->BindingGetFloat("auto_search") != 0)
		{
			int iContents = 0;
			{
				SService<ILinkSrv> pLS(g_pScriptManager);
				SService<ILinkToolsSrv> pLTS(g_pScriptManager);
				linkset ls;
				pLS->GetAll(ls, pLTS->LinkKindNamed("Contains"), m_iObjId, 0);
				for (true_bool __p; ls.AnyLinksLeft(__p), __p; ls.NextLink())
				{
					if (*reinterpret_cast<int*>(ls.query->Data()) < 0)
					{
						// At this point, CorpseFrobHack just returns
						// but this has caused problems, so we go the extra
						// step of checking the frob info.
						sLink sl;
						ls.query->Link(&sl);
						if (pPS->Possessed(sl.dest, "FrobInfo"))
						{
							cMultiParm mpFrob;
							pPS->Get(mpFrob, sl.dest, "FrobInfo", "World Action");
							if (static_cast<int>(mpFrob) & 0x1)
							{
								iContents = sl.dest;
								break;
							}
						}
					}
				}
			}

			if (iContents != 0)
			{
				SService<IContainSrv> pCS(g_pScriptManager);
				pCS->Add(iContents, static_cast<sFrobMsg*>(pMsg)->Frobber, 0, 1);
				if (pReply)
					MultiParmAssignInt(pReply, 0);
			}
		}
	}
#endif
	return 0;
}


/*****************
 * AIInteraction
 */
long __stdcall cScr_AIInteraction::OnInteract(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (pMsg->data.type != kMT_String || *pMsg->data.psz == '\0')
		return 1;
	
	sLink slInteraction;
	long iInteractLink = GetAnyLinkByData("ScriptParams", m_iObjId, 0, &slInteraction, pMsg->data.psz, -1);
	if (iInteractLink == 0)
	{
		iInteractLink = GetAnyLinkByData("ScriptParams", m_iObjId, 0, &slInteraction, NULL, 0);
		if (iInteractLink == 0)
			return 0;
		DebugPrintf("Running generic interaction (%d).", slInteraction.dest);
	}
	else
		DebugPrintf("Running \"%s\" interaction (%d).", pMsg->data.psz, slInteraction.dest);

	SimplePost(m_iObjId, slInteraction.dest, "TurnOn");

	return 0;
}

long __stdcall cScr_AIInteraction::OnSetInteraction(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	// unimplemented
	return 1;
}


/*****************
 * PlayerInteraction
 */
long __stdcall cScr_PlayerInteraction::OnToolFrob(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (!pPropSrv->Possessed(m_iObjId, "GameName"))
		return 1;
	cMultiParm mpName;
	pPropSrv->Get(mpName, m_iObjId, "GameName", NULL);
	const char* pszName = static_cast<const char*>(mpName);
	char *pszEnd;
	if ((pszEnd = strchr(pszName, ':')))
	{
		char buf[256];
		int n = pszEnd - pszName;
		if (n > 255)
			n = 255;
		strncpy(buf, pszName, n);
		buf[n] = '\0';
		mpName = buf;
	}

	SimplePost(m_iObjId, static_cast<sFrobMsg*>(pMsg)->DstObjId, "Interact", mpName);

	mpName.Free();
	return 0;
}

long __stdcall cScr_PlayerInteraction::OnContained(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!m_bSim)
		return 0;
	sContainedScrMsg* pContainMsg = static_cast<sContainedScrMsg*>(pMsg);
	if (pContainMsg->event != kContainAdd && pContainMsg->event != kContainCombine)
		return 1;

	SService<IObjectSrv> pObjSrv(g_pScriptManager);
	object oAvatar;
	pObjSrv->Named(oAvatar, "Avatar");
	true_bool __b;
	if (*(pObjSrv->InheritsFrom(__b, pContainMsg->container, oAvatar)))
	{
		object oSchema;
		pObjSrv->Named(oSchema, "new_speech");
		if (oSchema != 0)
		{
			SService<ISoundScrSrv> pSoundSrv(g_pScriptManager);
#if (_DARKGAME == 1)
			pSoundSrv->PlaySchemaAmbient(__b, m_iObjId, oSchema);
#else
			pSoundSrv->PlaySchemaAmbient(__b, m_iObjId, oSchema, kSoundNetwork0);
#endif
		}
	}

	return 0;
}
#endif


/*****************
 * AwarenessFilter
 */
bool cScr_AwarenessFilter::TestAwareness(int from, int to, int flags)
{
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	link l;
	pLS->GetOne(l, pLTS->LinkKindNamed("AIAwareness"), from, to);
	if (l != 0)
	{
		cMultiParm mpFlags = 0;
		pLTS->LinkGetData(mpFlags, l, "Flags");
		return (static_cast<int>(mpFlags) & flags) == flags;
	}
	return false;
}

long __stdcall cScr_AwarenessFilter::OnCanISeeYou(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	MultiParmAssignInt(pReply, TestAwareness(pMsg->from, m_iObjId, 0x85));
	return 0;
}

long __stdcall cScr_AwarenessFilter::OnCanIHearYou(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	MultiParmAssignInt(pReply, TestAwareness(pMsg->from, m_iObjId, 0x86));
	return 0;
}

long __stdcall cScr_AwarenessFilter::OnCanISeeObject(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = 0;
	if (pMsg->data.type == kMT_String)
	{
		obj = StrToObject(pMsg->data);
		if (!obj)
			return 1;
	}
	else
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		obj = static_cast<int>(pMsg->data);
		true_bool _p;
		if (! *pOS->Exists(_p, obj))
			return 1;
	}

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x85));
	return 0;
}

long __stdcall cScr_AwarenessFilter::OnCanIHearObject(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = 0;
	if (pMsg->data.type == kMT_String)
	{
		obj = StrToObject(pMsg->data);
		if (!obj)
			return 1;
	}
	else
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		obj = static_cast<int>(pMsg->data);
		true_bool _p;
		if (! *pOS->Exists(_p, obj))
			return 1;
	}

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x86));
	return 0;
}

long __stdcall cScr_AwarenessFilter::OnCanISeePlayer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = StrToObject("Player");
	if (!obj)
		return 1;

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x85));
	return 0;
}

long __stdcall cScr_AwarenessFilter::OnCanIHearPlayer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = StrToObject("Player");
	if (!obj)
		return 1;

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x86));
	return 0;
}


/**********************
 * TrapSignalAwareness
 */
struct sSignalAwarenessData
{
	cScrStr signal;
	int flags;
};
int cScr_SignalAwareness::AwareObjIter(ILinkSrv* pLS, ILinkQuery* pLQ, IScript* pScript, void* pData)
{
	sSignalAwarenessData* info = reinterpret_cast<sSignalAwarenessData*>(pData);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	SService<IAIScrSrv> pAISrv(g_pScriptManager);

	sLink slObj;
	pLQ->Link(&slObj);
	linkset lsLinks;
	pLS->GetAll(lsLinks, pLTS->LinkKindNamed("~AIAwareness"), slObj.dest, 0);
	for (true_bool __p; lsLinks.AnyLinksLeft(__p), __p; lsLinks.NextLink())
	{
		sLink slAI;
		lsLinks.query->Link(&slAI);
		cMultiParm mpFlags = 0;
		pLTS->LinkGetData(mpFlags, lsLinks.query->ID(), "Flags");
		if ((static_cast<int>(mpFlags) & info->flags) == info->flags)
		{
			pAISrv->Signal(slAI.dest, info->signal);
		}
	}
	return 1;
}

long __stdcall cScr_SignalAwareness::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		FixupPlayerLinks();
	}
	return 1;
}

long cScr_SignalAwareness::OnSwitch(bool bTurnOn, sScrMsg* pMsg, sMultiParm* pReply)
{
	if (bTurnOn)
	{
		char* pszSignal = GetObjectParamString(m_iObjId, "signal");
		if (!pszSignal)
			return 0;

		sSignalAwarenessData info;
		info.signal = pszSignal;
		info.flags = 0x84 | GetObjectParamInt(m_iObjId, "awareness");
		/*
		switch(GetObjectParamInt(m_iObjId, "awareness"))
		{
		case 3: // actually, I think this will never happen
			info.flags = 0x87;
			break;
		case 2:
			info.flags = 0x86;
			break;
		case 1:
			info.flags = 0x85;
			break;
		default:
			info.flags = 0x84;
			break;
		}
		*/

		IterateLinks(
#if (_DARKGAME == 3)
			"SwitchLink",
#else
			"ControlDevice", 
#endif
			m_iObjId, 0, AwareObjIter, this, reinterpret_cast<void*>(&info));
		
		g_pMalloc->Free(pszSignal);
	}

	return 0;
}


/**************
 * PrivateRoom
 */
#if (_DARKGAME == 3)
#define PRIVATEROOM_AI	"@Monsters"
#else
#define PRIVATEROOM_AI	"@Human"
#endif
void cScr_PrivateRoom::TestAwareness(int iMoveObjId)
{
	DebugString("Testing awareness");
	SService<IAIScrSrv> pAISrv(g_pScriptManager);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	linkset lsLinks;
	pLS->GetAll(lsLinks, pLTS->LinkKindNamed("~AIAwareness"), iMoveObjId, 0);
	for (true_bool __p; lsLinks.AnyLinksLeft(__p), __p; lsLinks.NextLink())
	{
		cMultiParm mpFlags = 0;
		pLTS->LinkGetData(mpFlags, lsLinks.query->ID(), "Flags");
		if ((static_cast<int>(mpFlags) & 0x89) == 0x89)
		{
			sLink sl;
			lsLinks.query->Link(&sl);
			char sz[12];
			sprintf(sz,"%d",sl.dest);
			DebugString("Signalling AI", sz);
			pAISrv->Signal(sl.dest, "alarm");
		}
	}
}

long __stdcall cScr_PrivateRoom::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "PrivateRoom")
	 && 0 != static_cast<int>(pMsg->data))
	{
		if (! m_bPlayerBreach)
		{
			DebugString("Removing links");
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->DestroyMany(pLTS->LinkKindNamed("AIWatchObj"), 
					PRIVATEROOM_AI, static_cast<const char*>(pMsg->data));
		}
		TestAwareness(static_cast<int>(pMsg->data));
		return 0;
	}
	return 1;
}

long __stdcall cScr_PrivateRoom::OnRoomEnter(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sRoomMsg* pRoomMsg = static_cast<sRoomMsg*>(pMsg);
	m_bPlayerBreach = 0;
	DebugString("PlayerEnter");
	SService<IObjectSrv> pOS(g_pScriptManager);
	object oMP;
	pOS->Named(oMP, "M-PlayerBreach");
	if (oMP == 0)
	{
		DebugString("Damn, no meta-prop");
		return 1;
	}
	true_bool _p;
	if (! *pOS->HasMetaProperty(_p, pRoomMsg->MoveObjId, oMP))
	{
		DebugString("Adding meta-prop");
		pOS->AddMetaProperty(pRoomMsg->MoveObjId, oMP);
	}

	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	char szPlayerDesc[12];
	sprintf(szPlayerDesc, "%d", pRoomMsg->MoveObjId);
	DebugString("Creating AIWatchObj links");
	linkkind lk = pLTS->LinkKindNamed("AIWatchObj");
	pLS->DestroyMany(lk, PRIVATEROOM_AI, szPlayerDesc);
	pLS->CreateMany(lk, PRIVATEROOM_AI, szPlayerDesc);
	
	TestAwareness(pRoomMsg->MoveObjId);

	return 0;
}

long __stdcall cScr_PrivateRoom::OnRoomExit(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	m_bPlayerBreach = 0;
	DebugString("PlayerExit");
	SService<IObjectSrv> pOS(g_pScriptManager);
	object oMP;
	pOS->Named(oMP, "M-PlayerBreach");
	if (oMP != 0)
	{
		pOS->RemoveMetaProperty(static_cast<sRoomMsg*>(pMsg)->MoveObjId, oMP);
	}
	int iTime = 1000;
	char* pszTime = GetObjectParamString(m_iObjId, "exit_time");
	if (pszTime)
	{
		if (*pszTime)
			iTime = strtotime(pszTime);
		g_pMalloc->Free(pszTime);
	}
	cMultiParm mpData = static_cast<sRoomMsg*>(pMsg)->MoveObjId;
	g_pScriptManager->SetTimedMessage2(m_iObjId, "PrivateRoom", iTime, kSTM_OneShot, mpData);
	return 0;
}

